//Javascript
jQuery.noConflict();
jQuery(document).ready(function(){	
    
    // Definindo o limite de caracteres do recado
    setLimiteRecado(1000);    
    

    jQuery('#postar_recado').css('display', 'none');
        
    // Exibe o formulario de envio do recado e gera o codigo captcha
    jQuery("#exibir_postar_recado").click(function(){
        exibirFormPostarRecado();
        gerarCaptcha();
    });
    
    // Gerar um novo captcha
    jQuery("#getCaptcha").click(function(){
        gerarCaptcha();
    });

    // Oculta o formulario de envio do recado
    jQuery("#cancelar_recado").click(function(){
        exibirFormPostarRecado();
    });

    // Envia o recado
    jQuery("#enviar_recado").click(function(){
        enviarRecado(jQuery("#nome_recado").val(), jQuery("#profissao_recado").val(), jQuery("#email_recado").val(), jQuery("#cidade_uf_recado").val(), jQuery("#mensagem_recado").val(), jQuery("#security_code").val());
    });
    	

});


// Funcao responsavel por ativar o limite de caracteres no recado
function setLimiteRecado(limiteCarecteresRecado){
    
    // Comeca setando o valor inicial na mensagem de alerta da qtde restante de caracteres
    jQuery('#caracteres_mensagem').text(limiteCarecteresRecado);
    
    // Valida a qtde de caracteres cada vez que pressiona uma tecla, e depois seta tal valor na mensagem de alerta
    jQuery('#mensagem_recado').keyup(function() {
      
        var digitos = this.value.length;
        
        if (digitos >= limiteCarecteresRecado) {
            this.value = this.value.substring(0, limiteCarecteresRecado);
        }
        
        // Essa validacao foi colocada para evitar o -1 que pode aparecer no alerta da mensagem
        if((limiteCarecteresRecado - digitos) < 1){
            restantes = 0;  
        }
        else{
            restantes = limiteCarecteresRecado - digitos;
        }
        
        jQuery('#caracteres_mensagem').text(restantes);
        
    });
    
}


function gerarCaptcha(){
    jQuery('#imagem_captcha').html('<img src="components/com_mymural/assets/css/loading.gif" alt="" /> Atualizando...');
    jQuery('#imagem_captcha').load('components/com_mymural/includes/Captcha.class.php?acao_captcha=gerar_captcha');

}

function exibirFormPostarRecado(){
    if (jQuery("#postar_recado").is(":hidden"))
        jQuery("#postar_recado").slideDown('normal');
    else
        jQuery("#postar_recado").slideUp('normal');
}

function enviarRecado(nome, profissao, email, cidade_uf, mensagem, codSeguranca){
    if (nome == ""){
        alert("Informe seu NOME, por favor!");
        jQuery("#nome_recado").focus();
        return;
    }    
    if (email == ""){
        alert("Informe seu E-MAIL, por favor!");
        jQuery("#email_recado").focus();
        return;
    }
    if (email.indexOf('@') < 0 || email.indexOf('.') < 0){
        alert("Informe um E-MAIL V\u00c1LIDO, por favor!");
        jQuery("#email_recado").focus();
        return;
    }
    if (profissao == ""){
        alert("Informe sua PROFISS\u00c3O, por favor!");
        jQuery("#profissao_recado").focus();
        return;
    }    
    if (cidade_uf == ""){
        alert("Informe sua CIDADE e ESTADO, por favor!");
        jQuery("#cidade_uf_recado").focus();
        return;
    }
    if (mensagem == ""){
        alert("Digite seu RECADO, por favor!");
        jQuery("#mensagem_recado").focus();
        return;
    }
    if (codSeguranca == ""){
        alert("Digite o C\u00d3DIGO DE SEGURAN\u00c7A por favor!");
        jQuery("#security_code").focus();
        return;
    }
	
    jQuery('#loading_mymural').show();
	
    jQuery.post("components/com_mymural/includes/Captcha.class.php?acao_captcha=validar_captcha", {
        cod_captcha: codSeguranca
    },
    function(retorno) {
        jQuery('#loading_mymural').hide();
        if(retorno.indexOf('session_erro') >= 0){
            alert('Erro ao criar a session do captcha.');
        }
        else if(retorno.indexOf('captcha_erro') >= 0){
            alert('C\u00f3digo incorreto. Tente novamente! \n Digite apenas letras min\u00fasculas.');
            jQuery("#security_code").val('');
            jQuery("#security_code").focus();
        }
        else if(retorno.indexOf('captcha_ok') >= 0){
            document.frm_postar_recado.submit();
        }
        else{
            alert(retorno);
        }
    }
    );

}