<?php

defined('_JEXEC') or die('Acesso restrito ao Joomla!');

jimport('joomla.application.component.controller');
jimport('joomla.filesystem.file');
jimport('joomla.utilities.utility');

include_once(JPATH_ROOT . DS . "administrator" . DS . "components" . DS . "com_mymural" . DS . "includes" . DS . "functions.class.php");
require_once(JPATH_ROOT . DS . "administrator" . DS . "components" . DS . "com_mymural" . DS . "includes" . DS . "wideimage_lib" . DS . "WideImage.inc.php");

//Para a classe JTable funcionar, deve-se importá-la aqui...
JTable::addIncludePath(JPATH_COMPONENT . DS . 'tables');

class MymuralController extends JController {

    function __construct($default = array()) {

        parent::__construct($default);

        $this->registerTask('enviar_recado', 'enviar_recado'); //$this->registerTast('task enviada', 'function chamada pela task');
        $this->registerTask('pesquisar_mymural', 'pesquisar_mymural');
    }

    function pesquisar_mymural() {
        
        global $option, $mainframe;
        
        JRequest::checkToken() or jexit('Tokem inválido!');

        $model = $this->getModel('recados');
        
        $pesquisa = JRequest::getVar('search', '', 'post', 'string', JREQUEST_ALLOWRAW);

        //Setando para a sessao o conteudo a ser pesquisado, e se estiver vazio, zera a pesquisa e lista tudo
        $session =& JFactory::getSession();
        $session->set('pesquisaMyMural', $pesquisa);

        //Redirecionando novamente para o mural de recados
        //$link = 'mural-de-recados';
        $link = 'index.php?option=' . $option. '&view=recados';
        $this->setRedirect($link, $msg);

    }

    function enviar_recado() {

        global $option, $mainframe;

        JRequest::checkToken() or die('Token Inválido'); //Aqui gera um tipo de chave de segurança, que se não for a mesma gerada pelo Framework, há suspeita de invasão e a ação é cancelada.

        $row = & JTable::getInstance('mymural', 'Table'); //Cria uma instancia da classe TableMymural, obtendo o vínculo com a tabela mymural

        if (!$row->bind(JRequest::get('post'))) { //liga o array dos elementos gerados por POST  aos atributos da classe TableMymural
            echo "<script> alert('" . $row->getError() . "'); window.history.go(-1);</script>\n";
            exit();
        }

        $area = JRequest::getVar('area_recado', '', 'post', 'string', JREQUEST_ALLOWRAW);
        $nome = JRequest::getVar('nome_recado', '', 'post', 'string', JREQUEST_ALLOWRAW);
        $profissao = JRequest::getVar('profissao_recado', '', 'post', 'string', JREQUEST_ALLOWRAW);
        $email = JRequest::getVar('email_recado', '', 'post', 'string', JREQUEST_ALLOWRAW);
        $cidade_uf = JRequest::getVar('cidade_uf_recado', '', 'post', 'string', JREQUEST_ALLOWRAW);

        $mensagem = (JRequest::getVar('mensagem_recado', '', 'post', 'string', JREQUEST_ALLOWRAW));

        $mensagem = strip_tags($mensagem); //Removendo possiveis codigos HTML na mensagem... hehehe
        $mensagem = nl2br($mensagem);
        $dataAtual = date('Y-m-d H:i:s');

        //Manipulação da Imagem
        $imagem = JRequest::getVar('foto_recado', null, 'files', 'array');

        if ($imagem['name'] != null) {

            $cod_imagem = rand(1111111111, time());
            $extensao = JFile::makeSafe(strtolower(end(explode('.', $imagem['name']))));

            $nomeImagem = "mymural_" . $cod_imagem . "." . $extensao;

            $src = $imagem['tmp_name'];
            $dirDestino = JPATH_ROOT . DS . "images" . DS . "mymural" . DS . $nomeImagem;

            //Aqui usa os métodos da LIB WideImage, pra redimensionar e salvar a imagem no tamanho correto
            /*
             * resize(largura, altura, tipo de redimensionamento "proporcional, se preenche tudo, etc", direção "só redimensiona se for maior, sempre redimensiona, etc...")
             */
            if (!wiImage::load($imagem['tmp_name'])->resize(120, 120, 'inside', 'down')->saveToFile($dirDestino)) {
                //$row->imagem = "images/mymural/" . $nomeImagem;
                $fotoRecado = "images/mymural/" . $nomeImagem;
            } else {
                $msg = "Recado enviado com sucesso!<br /><em>Erro ao fazer o upload da imagem.</em>";
            }
        } else {
            $fotoRecado = "";
        }
        //Fim da manipulação da imagem
        //Capturando os parâmetros do componente para atualizar o status do recado (publicado ou não)
        $params = & JComponentHelper::getParams('com_mymural');
        $statusPublicado = $params->get('bloquear_recados');

        $publica = '1';

        if ($statusPublicado == '1') {
            $msg = 'Recado enviado com Sucesso! <em>Aguarde a aprovação de seu recado pelos Administradores do Sistema!</em>';
            $publica = '0';
        } else {
            $publica = '1';
        }

        /* Enviando os dados para o arquivo table mymural.php */
        $row->area = $area;
        $row->nome = $nome;
        $row->profissao = $profissao;
        $row->email = $email;
        $row->cidade_uf = $cidade_uf;
        $row->mensagem = $mensagem;
        $row->published = $publica;
        $row->data_cadastro = $dataAtual;
        $row->imagem = $fotoRecado;

        $erro = false;


        if (trim($area) == "" || $area == null || $area == '0') {
            $erro = true;
            $msg = JText::_('Atenção: O campo AREA deve ser preenchido!');
            $mainframe->enqueueMessage($msg, 'error');
        } else if (trim($nome) == "" || $nome == null) {
            $erro = true;
            $msg = JText::_('Atenção: O campo NOME deve ser preenchido!');
            $mainframe->enqueueMessage($msg, 'error');
        } else if (trim($profissao) == "" || $profissao == null) {
            $erro = true;
            $msg = JText::_('Atenção: O campo PROFISSÃO deve ser preenchido!');
            $mainframe->enqueueMessage($msg, 'error');
        } else if (trim($email) == "" || $email == null) {
            $erro = true;
            $msg = JText::_('Atenção: O campo E-MAIL deve ser preenchido!');
            $mainframe->enqueueMessage($msg, 'error');
        } else if (!eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,3})$", $email)) {
            $erro = true;
            $msg = JText::_('Atenção: E-MAIL inválido! Tente novamente');
            $mainframe->enqueueMessage($msg, 'error');
        } else if (trim($cidade_uf) == "" || $cidade_uf == null) {
            $erro = true;
            $msg = JText::_('Atenção: O campo CIDADE/UF deve ser preenchido!');
            $mainframe->enqueueMessage($msg, 'error');
        } else if (trim($mensagem) == "" || $mensagem == null) {
            $erro = true;
            $msg = JText::_('Atenção: O campo MENSAGEM deve ser preenchido!');
            $mainframe->enqueueMessage($msg, 'error');
        } else if (!$row->store()) { //Executa a gravação dos atributos recuperados na tabela #__mymural
            echo "<script> alert('" . $row->getError() . "'); window.history.go(-1);</script>\n";
            exit();
        }

        /*
          $db = JFactory::getDBO();
          $query = "INSERT INTO #__mymural VALUES(0, '$area', '$nome', '$profissao', '$email', '$cidade_uf', '$fotoRecado', '$mensagem', $publica, 0, now())";
          $db->setQuery($query);
          if(!$db->query()) {
          $msg = 'Houve um erro ao enviar seu recado. Por favor, tente novamente!<br />';
          } */ else {

            //Se existir algum email definido nas Preferências do componente, ele envia o a notificação de novo recado nos emails descritos

            $params = & JComponentHelper::getParams('com_mymural');
            $emailsMymural = $params->get('emails_mymural');

            $config = & JFactory::getConfig();
            $emailFrom = $config->getValue('config.mailfrom');

            if ($emailsMymural != "" || $emailsMymural != null) {

                $dataEnvio = substr($dataAtual, 8, 2) . '/' . substr($dataAtual, 5, 2) . '/' . substr($dataAtual, 0, 4) . ' - ' . substr($dataAtual, 11, 8); //2010-08-03 12:03:50 

                $db = JFactory::getDBO();

                //Capturando o nome da área baseado no código escolhido
                $query = "SELECT nome FROM #__mymural_areas WHERE id = " . $area;
                $db->setQuery($query);
                $areaRecado = $db->loadResult();
                $url = JURI::base();
                ;

                $from = $emailFrom;
                $fromname = "MyMural - " . $siteName;
                $recipient = $emailsMymural;
                $subject = 'Novo recado postado no Mural';
                $body = '
				Novo recado no site: <a href="' . $url . '" title="Clique aqui para acessar o site">' . $url . '</a><br /><br />
				<strong>Area:</strong> ' . $areaRecado . '<br />
				<strong>Nome:</strong> ' . $nome . '<br />
				<strong>Profissao:</strong> ' . $profissao . '<br />
				<strong>E-mail:</strong> ' . $email . '<br />
				<strong>Localidade:</strong> ' . $cidade_uf . '<br /><br />
				<strong>Mensagem:</strong> <br />' . $mensagem . '<br /><br />
				
				<strong>O recado foi postado em ' . $dataEnvio . '</strong>';

                JUtility::sendMail($from, $fromname, $recipient, $subject, $body, $mode = true, $cc = null, $bcc = null, $attachment = null, $replyto = null, $replytoname = null);
            }
        }



        //Este switch valida se foi acionado o botão aplicar ou Salvar, para montar a URL corretamente.
        switch ($this->_task) {
            case 'save':
            default:
                //$link = 'mural-de-recados';
                $link = 'index.php?option=' . $option. '&view=recados';
                break;
        }

        //Ser a validação encontrar algum erro, irá exibir a mensagem de erro somente
        if ($erro == true)
            $this->setRedirect($link); //Direciona o fluxo para a URL montada no switch
        else
            $this->setRedirect($link, $msg); //Direciona o fluxo para a URL montada no switch
    }

//save()
    //Function para enviar o recado via email
    function sendMail($from, $fromname, $recipient, $subject, $body, $mode=0, $cc, $bcc=null, $attachment=null, $replyto=null, $replytoname=null) {
        // Get a JMail instance
        $mail = &JFactory::getMailer();

        $mail->setSender(array($from, $fromname));
        $mail->setSubject($subject);
        $mail->setBody($body);

        // Are we sending the email as HTML?
        if ($mode) {
            $mail->IsHTML(true);
        }

        $mail->addRecipient($recipient);
        $mail->addCC($cc);
        $mail->addBCC($bcc);
        $mail->addAttachment($attachment);

        // Take care of reply email addresses
        if (is_array($replyto)) {
            $numReplyTo = count($replyto);
            for ($i = 0; $i < $numReplyTo; $i++) {
                $mail->addReplyTo(array($replyto[$i], $replytoname[$i]));
            }
        } elseif (isset($replyto)) {
            $mail->addReplyTo(array($replyto, $replytoname));
        }

        return $mail->Send();
    }

}

?>