<?php

defined('_JEXEC') or die();

jimport('joomla.application.component.model');

class MymuralModelRecados extends JModel {

    var $_data = null;
    var $_total = null;
    var $_pagination = null;
    var $_where = null;
    
    function __construct() {
        
        parent::__construct();

        global $mainframe, $option;

        //pega no arquivo de configuracao quantos recados ira exibir por pagina. O padrao eh 5
        $params = & JComponentHelper::getParams('com_mymural');
        $limit = $params->get('limite_paginacao');

        if ($limit < 5 || $limit == "") {
            $limit = 5;
        }
        $limitstart = JRequest::getVar('limitstart', 0, '', 'int');

        $this->setState('limit', $limit);
        $this->setState('limitstart', $limitstart);       
        
        //Captura a sessao de pesquisa, para listar os recados baseado no parametro recebido
        $session =& JFactory::getSession();
        $pesquisaMyMural = $session->get('pesquisaMyMural');
        
        $this->_where = $pesquisaMyMural;
                
    }

    function getBusca(){
        return $this->_where;
    }
    
    /**
     * Método responsável por capturar o total de registros
     * @access public
     * @return integer
     */
    function getTotal(){
        
        if (empty($this->_total)) {

            //Obtendo o total de recados            
            $query = $this->_buildQuery();
            $this->_total = $this->_getListCount($query);
        }

        return $this->_total;
    }
    
    /**
     * Captura um objeto de Paginacao
     * @access public
     * @return integer
     */
    function getPagination() {
        // Load the content if it doesn't already exist
        if (empty($this->_pagination)) {
            jimport('joomla.html.pagination');            
            $this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit'));
        }
        return $this->_pagination;
    }
    
    function getTitulo() {

        $params = & JComponentHelper::getParams('com_mymural');
        $tituloMural = $params->get('titulo_mymural');

        //se não foi setado nenhum título nas preferências do componente, recebe o título de Mural de Recados
        if ($tituloMural == "" || $tituloMural == null) {
            $tituloMural = "Mural de Recados - MyMural";
        }
        return $tituloMural;
    }

    function getIntroducao() {

        //Verificando se existe um texto de introdução
        $query = "SELECT params FROM #__components WHERE admin_menu_link = 'option=com_mymural&task=texto_introducao'";
        $this->_db->setQuery($query);
        $texto = $this->_db->loadResult();

        return $texto;
    }
    
    
    /**
     * Recupera os dados da tabela #__mymural
     * @return Array com os dados
     */
    function getData() {

        if (empty($this->_data)) {

            $query = $this->_buildQuery();

            $this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
        }

        //echo 'Valor de pesquisa: ' . $this->getWhere();
        return $this->_data;
    }
    
    
    /**
     * Retorna a query
     * @return retorna a query com as linhas do BD
     */
    function _buildQuery() {
        
        // Pega as cláusulas WHERE e ORDER BY para a query
        $where = $this->_buildContentWhere();
        $orderby = $this->_buildContentOrderBy();

        //$query = "SELECT a.* FROM #__mymural AS a $where $orderby";
        $query = "SELECT a.*, j.nome as nome_area FROM #__mymural as a INNER JOIN #__mymural_areas as j ON a.area = j.id $where $orderby";        
        return $query;
    }

    /**
     * Query feita para gerar o conteúdo baseado na ordem setada
     * @return retorna a query com as linhas do BD
     */
    function _buildContentOrderBy() {

        global $mainframe, $option;

        $filter_order = $mainframe->getUserStateFromRequest($option . 'filter_order', 'filter_order', 'a.id', 'cmd');

        //Verifica que ordem de filtragem foi setada
        $filter_order = ($filter_order == "a.ordering") ? "a.id" : $filter_order;

        $filter_order_Dir = $mainframe->getUserStateFromRequest($option . 'filter_order_Dir', 'filter_order_Dir', 'desc', 'word');

        $orderby = "ORDER BY $filter_order $filter_order_Dir";

        return $orderby;
    }

    /**
     * Query feita para gerar o conteúdo baseado no que foi setado no WHERE
     * @return retorna a query com as linhas do BD
     */
    function _buildContentWhere() {

        global $mainframe, $option;

        $db =& JFactory::getDBO();

//        $filter_state = $mainframe->getUserStateFromRequest($option . 'filter_state', 'filter_state', '', 'word');
//        $search = $mainframe->getUserStateFromRequest($option . 'search', 'search', '', 'string');

        $search = JString::strtolower($this->_where);

        $where = array();

        if ($search) {

            $oi = '(LOWER(a.nome) LIKE ' . $db->Quote('%' . $db->getEscaped($search, true) . '%', false);
            $oi .= ' OR LOWER(a.profissao) LIKE ' . $db->Quote('%'.$db->getEscaped($search, true).'%', false);           
            $oi .= ' OR LOWER(a.email) LIKE ' . $db->Quote('%'.$db->getEscaped($search, true).'%', false);           
            $oi .= ' OR LOWER(j.nome) LIKE ' . $db->Quote('%'.$db->getEscaped($search, true).'%', false);           
            $oi .= ' OR LOWER(a.cidade_uf) LIKE ' . $db->Quote('%' . $db->getEscaped($search, true) . '%', false) . ')';
            $oi .= '';
            $where[] = $oi;
        }

        $where = (count($where) ? ' WHERE a.published = 1 AND ' . implode(' AND ', $where) : ' WHERE a.published = 1');      

        return $where;
    }

}

?>